<template>
  <div class="simple-keyboard"></div>
</template>

<script lang="ts">
import Keyboard from 'simple-keyboard';

import 'simple-keyboard/build/css/index.css';

const latinLayout = {
  layout: {
    default: [
      "` 1 2 3 4 5 6 7 8 9 0 - = {bksp}",
      "{tab} q w e r t y u i o p [ ] \\",
      "{lock} a s d f g h j k l ; ' {enter}",
      "{shift} z x c v b n m , . / {shift}",
      "@ {space}",
    ],
    shift: [
      "~ ! @ # $ % ^ & * ( ) _ + {bksp}",
      "{tab} Q W E R T Y U I O P { } |",
      '{lock} A S D F G H J K L : " {enter}',
      "{shift} Z X C V B N M < > ? {shift}",
      "@ {space}",
    ],
  },
};

const arabicLayout = {
  layout: {
    default: [
      "\u0630 1 2 3 4 5 6 7 8 9 0 - = {bksp}",
      "{tab} \u0636 \u0635 \u062B \u0642 \u0641 \u063A \u0639 \u0647 \u062E \u062D \u062C \u062F \\",
      "{lock} \u0634 \u0633 \u064A \u0628 \u0644 \u0627 \u062A \u0646 \u0645 \u0643 \u0637 {enter}",
      "{shift} \u0626 \u0621 \u0624 \u0631 \u0644\u0627 \u0649 \u0629 \u0648 \u0632 \u0638 {shift}",
      "@ {space}",
    ],
    shift: [
      "\u0651 ! @ # $ % ^ & * ) ( _ + {bksp}",
      "{tab} \u064E \u064B \u064F \u064C \u0644\u0625 \u0625 \u2018 \u00F7 \u00D7 \u061B < > |",
      '{lock} \u0650 \u064D ] [ \u0644\u0623 \u0623 \u0640 \u060C / : " {enter}',
      "{shift} ~ \u0652 } { \u0644\u0622 \u0622 \u2019 , . \u061F {shift}",
      "@ {space}",
    ],
  },
};

export default {
  name: 'Keyboard',
  props: {
    input: {
      type: String
    },
    layout: {
      type: String
    }
  },
  data: () => ({
    keyboard: null,
    syriacLayout: {
      layout: {
        // See: https://syriaca.org/geo/$nav-base/resources/keyboard/syr/syr.js
        "default" : [
          "\u070f 1 2 3 4 5 6 7 8 9 0 - = {bksp}",
          "{tab} \u0729 \u0718 \u0716 \u072a \u072c \u071d \u071c \u0725 \u0727 \u0726 ] [ \u0706",
          "{lock} \u0710 \u0723 \u0715 \u0714 \u0713 \u0717 \u071b \u071f \u0720 \u071a \u071e {enter}",
          "{shift} \u0719 \u0728 \u0724 \u072b \u0712 \u0722 \u0721 \u0700 . \u0707 {shift}",
          "{alt} {space} {alt}"
        ],
        "shift" : [
          "\u032e ! \u030a \u0325 \u0749 \u2670 \u2671 \u070a \u00ab ) ( \u00bb + {bksp}",
          "{tab} \u0730 \u0733 \u0736 \u073a \u073d \u0740 {//} \u0308 \u0304 \u0741 \u0303 \u074a \u0703",
          "{lock} \u0731 \u0734 \u0737 \u073b \u073e \u0711 \u0640 \u0738 \u0331 \u0742 \u0330 {enter}",
          "{shift} \u0732 \u0735 \u0738 \u073c \u073f \u0739 {//} \u060c \u061b \u2e2e {shift}",
          "{alt} {space} {alt}"
        ],
        "alt" : [
          "\u0651 \u0701 \u0702 \u0703 \u0704 \u0705 \u0708 \u0709 \u070b \u070c \u070d \u250c \u2510 {bksp}",
          "{tab} \u064e \u064b \u064f \u064c \u0653 \u0654 \u0747 \u0743 \u0745 \u032d {//} {//} {//}",
          "{lock} \u0650 \u064d {//} \u0621 \u0655 \u0670 \u0748 \u0744 \u0746 {//} {//} {enter}",
          "{shift} {//} \u0652 {//} {//} {//} {//} {//} {//} {//} {//} {shift}",
          "{alt} {space} {alt}",
          ]
      },
    }
  }),
  mounted() {
    const layout = this.getCurrentLayout(this.layout);
    this.keyboard = new Keyboard({
      onChange: this.onChange,
      onKeyPress: this.onKeyPress,
      layout
    });
    this.keyboard.setInput(this.input);
  },
  methods: {
    onChange(input) {
      this.$emit('change', input);
    },
    onKeyPress(button) {
      this.$emit('key-press', button);
      if (button === '{shift}' || button === '{lock}') this.handleShift();
      if (button === '{alt}') this.handleAlt();
    },
    handleShift() {
      let currentLayout = this.keyboard.options.layoutName;
      let shiftToggle = currentLayout === 'shift' ? 'default' : 'shift';

      this.keyboard.setOptions({
        layoutName: shiftToggle
      });
    },
    handleAlt() {
      let currentLayout = this.keyboard.options.layoutName;
      let altToggle = currentLayout === 'alt' ? 'default' : 'alt';

      this.keyboard.setOptions({
        layoutName: altToggle
      });
    },
    getCurrentLayout(value) {
      let layout = latinLayout.layout;
      if (value === 'arabic') {
        layout = arabicLayout.layout;
      } else if (value === 'syriac') {
        layout = this.syriacLayout.layout;
      }

      return layout;
    }
  },
  watch: {
    input(value) {
      this.keyboard.setInput(value);
    },
    layout(value) {
      const layout = this.getCurrentLayout(value);
      this.keyboard.setOptions({ layout });
    }
  }
};
</script>

<style scoped>
.simple-keyboard {
  padding: 8px;
  border-radius: 0;

}
:deep(.hg-button-space) {
  min-width: 70%;
}

.hg-theme-default {
  background: var(--c-details-bg);
}

:deep(.hg-button) {
  background: var(--c-bg);
  border-bottom-color: var(--c-bg-light);
}

:deep(.hg-button.hg-activeButton) {
  background: var(--c-bg-dark);
}
</style>
